<?php
class core {
    public static $root = '../';
    public static $ip; // Путь к корневой папке
    public static $ip_via_proxy = 0; // IP адрес за прокси-сервером
    public static $user_agent; // User Agent
    public static $user_data = array(); // Все данные пользователя

    function __construct() {
        // Получаем IP адреса
        $ip = ip2long($_SERVER['REMOTE_ADDR']) or die('Invalid IP');
        self::$ip = sprintf("%u", $ip);
        if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $vars)) {
            foreach ($vars[0] AS $var) {
                $ip_via_proxy = ip2long($var);
                if ($ip_via_proxy && $ip_via_proxy != $ip && !preg_match('#^(10|172\.16|192\.168)\.#', $var)) {
                    self::$ip_via_proxy = sprintf("%u", $ip_via_proxy);
                    break;
                }
            }
        }
        // Получаем UserAgent
        if (isset($_SERVER["HTTP_X_OPERAMINI_PHONE_UA"]) && strlen(trim($_SERVER['HTTP_X_OPERAMINI_PHONE_UA'])) > 5) {
            self::$user_agent = 'Opera Mini: ' . htmlspecialchars(mb_substr(trim($_SERVER['HTTP_X_OPERAMINI_PHONE_UA']), 0, 150));
        } elseif (isset($_SERVER['HTTP_USER_AGENT'])) {
            self::$user_agent = htmlspecialchars(mb_substr(trim($_SERVER['HTTP_USER_AGENT']), 0, 150));
        } else {
            self::$user_agent = 'Not Recognised';
        }
        //
        $this -> session_start(); // Стартуем сессию
        $this -> auth(); // Авторизация пользователей

    }
    //фильтрация
    public static function checkin($str) {
        if (function_exists('iconv')) {
            $str = iconv("UTF-8", "UTF-8", $str);
        }
        $str = preg_replace('/[^\P{C}\n]+/u', '', $str); // Фильтруем невидимые символы
        return trim($str);
    }
    //сессия
    private function session_start(){
        session_name('SESID');
        session_start();
    }
    //Проверка авторизации пользователя//
    private function auth(){
        if(isset($_COOKIE['idsite']) && isset($_COOKIE['passsite'])){
            $us = intval($_COOKIE['idsite']); //ид площаки
            $upassword = core::checkin($_COOKIE['passsite']); //фильтруем пароль
            if(empty($us) or empty($upassword)){ //чистим данные если кто то вдруг пытается подменить
                setcookie('idsite', '', time()-((60*60)*24), '/');
                setcookie('passsite', '', time()-((60*60)*24), '/');
            }
            //вынемаем данные о площадке
            $user_data = DB::$dbs->queryFetch("SELECT * FROM `iframe` WHERE `id` = ? and `pass`= ? LIMIT 1",array($us,$upassword));
            //выводим переменные в глубь движка
            self::$user_data = $user_data;
            //присваиваем значения
            $_SESSION['user_id'] = $user_data['id'];
            //и тут если ошибка то чистим всё
            if(isset($user_data['id']) && $user_data['id']!=$us or $user_data['pass']!=$upassword){
                setcookie('idsite', '', time()-((60*60)*24), '/');
                setcookie('passsite', '', time()-((60*60)*24), '/');
            }
        }
    }
    //запись гостей
    /*
    private function gosti(){
        //записываем гостей
        if(DB::$dbs->query("SELECT `id` FROM `gosti` WHERE `ip` = ? and `agent` = ? LIMIT 1",array(core::$ip,core::$user_agent))->rowCount()==0){
            //делаем реферер
            if(isset($_SERVER['HTTP_REFERER'])){
                //разбираем ссылку
                $sitee = trim(parse_url(core::checkin($_SERVER['HTTP_REFERER']), PHP_URL_HOST));
                //выборка
                if(strlen($sitee) > 0){$riki = $sitee;}else{$riki = 'fload.xyz';}
                //остальное
                $ss = 1;
            }else{
                $riki = 'fload.xyz';
            }
            //записываем в бд гостей
            DB::$dbs->query("INSERT INTO `gosti` SET `ip` = ?,`ip2` = ?,`time` = ?,`agent` = ?,`referer` = ?,`mobe` = ?",array(core::$ip,core::checkin($_SERVER['REMOTE_ADDR']),time(),core::$user_agent,$riki,functions::webes()));
            //добавляем от куда перешли
            if($ss == 1){
                //смотрим была ли ссылка уже в базе
                if(DB::$dbs->query("SELECT `id` FROM `refers` WHERE `url` = ? LIMIT 1",array($riki))->rowCount()==0){
                    DB::$dbs->query("INSERT INTO `refers` SET `url` = ?,`cool` = ?",array($riki,1));
                }else{
                    DB::$dbs->query("UPDATE `refers` SET `cool` = `cool` + ? WHERE `url` = ? LIMIT 1",array(1,$riki));
                }
            }
            //записываем страну
            $sttt = functions::geo(core::checkin($_SERVER['REMOTE_ADDR']));
            if(DB::$dbs->query("SELECT `id` FROM `strana` WHERE `naz` = ? LIMIT 1",array($sttt))->rowCount()==0){
                DB::$dbs->query("INSERT INTO `strana` SET `naz` = ?,`cool` = ?",array($sttt,1));
            }else{
                DB::$dbs->query("UPDATE `strana` SET `cool` = `cool` + ? WHERE `naz` = ? LIMIT 1",array(1,$sttt));
            }
        }else{
            DB::$dbs->query("UPDATE `gosti` SET `time` = ? WHERE `ip` = ? LIMIT 1",array(time(),core::$ip));
        }
    }
    */
}
?>